# Create MIX opcode tables from mixal.optab
# Copyright (C) 2000,2005 Sergey Poznyakoff
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc.
# 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

BEGIN {
    abind = 0
    lastop=-1
}

/^#.*/ { next }

NF>=3 {
        if ($1 > lastop)
	    lastop = $1
		
	rab[abind] = $2
        # flg[abind] = $3
        opc[abind] = $1
	count[ $1 ] ++
        if (match($3, "[0-9]:[0-9]")) {
	    L = substr($3, 1, 1)+0
	    R = substr($3, 3, 1)+0
	    def[ abind ] = 8*L + R
            fld[ abind ] = 1
	} else {
	    def[ abind ] = $3+0
	    fld[ abind ] = 0
	}
	abind++
}

END {
     print "/* This file is generated automatically. Please do not edit */"
     print "#include \"mix.h\""
     print ""	  
     print "/* mixal table */"
     print "struct mix_op mix_optab[] = {";	   
     printf("/*     MNEM DFLD  OPCODE FLD */\n");    
     for (n = 0; n < abind; n++) {
	  printf("    { %6s, %4d, %4d, %4d },\n", "\"" rab[n] "\"" , def[n], opc[n], fld[n]);
     }
     print "};"
     print "int op_count = sizeof(mix_optab)/sizeof(mix_optab[0]);"
     printf "/* count */\n";
     printf "int dd_cnt[] = {"
     elcnt = 0
     ind = 0
     for (n = 0; n <= lastop; n++) {
	if (elcnt++ % 10 == 0)
	    printf "\n\t"
        printf "%4d, ", count[n]
	entry[n] = ind
        ind += count[n]
     }
     printf "\n};\n";

     printf "/* entry points */\n"
     printf "int dd_ent[] = {"
     elcnt = 0;
     for (n = 0; n <= lastop; n++) {
	if (elcnt++ % 10 == 0)
	    printf "\n\t"
        printf "%4d, ", entry[n]
     }
     printf "\n};\n";
}








